POJ 3264-Balanced Lineup(段树:单点更新,间隔查询)

简介:
Balanced Lineup
Time Limit: 5000MS   Memory Limit: 65536K
Total Submissions: 34522   Accepted: 16224
Case Time Limit: 2000MS

Description

For the daily milking, Farmer John's N cows (1 ≤ N ≤ 50,000) always line up in the same order. One day Farmer John decides to organize a game of Ultimate Frisbee with some of the cows. To keep things simple, he will take a contiguous range of cows from the milking lineup to play the game. However, for all the cows to have fun they should not differ too much in height.

Farmer John has made a list of Q (1 ≤ Q ≤ 200,000) potential groups of cows and their heights (1 ≤ height ≤ 1,000,000). For each group, he wants your help to determine the difference in height between the shortest and the tallest cow in the group.

Input

Line 1: Two space-separated integers,  N and  Q
Lines 2.. N+1: Line  i+1 contains a single integer that is the height of cow  i 
Lines  N+2.. N+ Q+1: Two integers  A and  B (1 ≤  A ≤  B ≤  N), representing the range of cows from  A to  B inclusive.

Output

Lines 1.. Q: Each line contains a single integer that is a response to a reply and indicates the difference in height between the tallest and shortest cow in the range.

Sample Input

6 3
1
7
3
4
2
5
1 5
4 6
2 2

Sample Output

6
3
0

Source

经ysj一说我也准备噜线段树了 那天下午他来给我讲了一下线段树。先敲个模板再说。。

题意是找某个区间的最大值和最小值的差值。

#include <cstdio>
#include <iostream>
#include <algorithm>
#include <cstring>
#include <cctype>
#include <cmath>
#include <cstdlib>
#include <vector>
#include <queue>
#include <set>
#include <map>
#include <list>
#define LL long long
using namespace std;
const int INF=1<<27;
const int maxn=200010;
LL minn[maxn],maxx[maxn];
void update(LL root,LL l,LL r,LL p,LL v)//单点更新
{
	if(l==r) maxx[root]=v;minn[root]=v;
	if(l<r)
	{
		LL mid=(l+r)/2;
		if(p<=mid) update(root*2,l,mid,p,v);
		else update(root*2+1,mid+1,r,p,v);
		maxx[root]=max(maxx[root*2],maxx[root*2+1]);
		minn[root]=min(minn[root*2],minn[root*2+1]);
	}
}
LL query_min(LL root,LL l,LL r,LL ql,LL qr)
{
	LL mid=(l+r)/2,ans=INF;
	if(ql<=l&&qr>=r) return minn[root];
	if(ql<=mid) ans=min(ans,query_min(root*2,l,mid,ql,qr));
	if(qr>mid) ans=min(ans,query_min(root*2+1,mid+1,r,ql,qr));
	return ans;
}
LL query_max(LL root,LL l,LL r,LL ql,LL qr)
{
	LL mid=(l+r)/2,ans=-INF;
	if(ql<=l&&qr>=r) return maxx[root];
	if(ql<=mid) ans=max(ans,query_max(root*2,l,mid,ql,qr));
	if(qr>mid) ans=max(ans,query_max(root*2+1,mid+1,r,ql,qr));
	return ans;
}
int main()
{
  int N,Q,i,v;
  while(~scanf("%lld%lld",&N,&Q))
  {
  	for(i=1;i<=N;i++)
	{
		scanf("%lld",&v);
		update(1,1,N,i,v);
	}
	while(Q--)
	{
		int ql,qr;
		scanf("%lld%lld",&ql,&qr);
		printf("%lld\n",query_max(1,1,N,ql,qr)-query_min(1,1,N,ql,qr));
	}
  }
  return 0;
}








本文转自mfrbuaa博客园博客,原文链接:http://www.cnblogs.com/mfrbuaa/p/5041618.html,如需转载请自行联系原作者

相关文章
|
5月前
|
SQL 存储 关系型数据库
ADBPG&Greenplum成本优化问题之查询大表的dead tuple占比和空间如何解决
ADBPG&Greenplum成本优化问题之查询大表的dead tuple占比和空间如何解决
39 1
|
7月前
每日一题 2006. 差的绝对值为 K 的数对数目
每日一题 2006. 差的绝对值为 K 的数对数目
用c/c++代码求解时分秒针重合次数
用c/c++代码求解时分秒针重合次数
[UVA1364 | POJ | NC]Knights of the Round Table | Tarjan 求点双 | 二分图 | 综合图论
我们可以很轻松地发现,被提出的都是在点双连通分量之外的,比如该图中的1 和 5 ,那么怎么判断哪些点不在环中呢? 此时我们还可以逆向思考,不 在 环 中 的 = = 总 的 − 在 环 中 的,所以说现在问题就转换成了满足条件的环内的点的个数
135 0
[UVA1364 | POJ | NC]Knights of the Round Table | Tarjan 求点双 | 二分图 | 综合图论
|
JavaScript
[路飞]_leetcode-1124-表现良好的最长时间段
leetcode-1124-表现良好的最长时间段
【1142】Maximal Clique (25分)【有点问题】
【1142】Maximal Clique (25分)【有点问题】 【1142】Maximal Clique (25分)【有点问题】
86 0
|
Java
[LeetCode]Longest Continuous Increasing Subsequence 最长连续增长序列
链接:https://leetcode.com/problems/longest-continuous-increasing-subsequence/description/难度:Easy题目:674.
1099 0